diff --git a/src/backend/storage/ipc/procarray.c b/src/backend/storage/ipc/procarray.c
index d3b94e7..fc37a1c 100644
--- a/src/backend/storage/ipc/procarray.c
+++ b/src/backend/storage/ipc/procarray.c
@@ -17,6 +17,28 @@
  * as are the myProcLocks lists.  They can be distinguished from regular
  * backend PGPROCs at need by checking for pid == 0.
  *
+ * During recovery, we also keep a list of XIDs representing transactions
+ * that are known to be running at current point in WAL recovery. This
+ * list is kept in the UnobservedXids array, and updated by watching
+ * the sequence of arriving xids. This is very important because if we leave
+ * those xids out of the snapshot then they will appear to be already complete.
+ * Later, when they have actually completed this could lead to confusion as to
+ * whether those xids are visible or not, blowing a huge hole in MVCC.
+ * We need 'em.
+ *
+ * XXX Although we have max_connections procs during recovery, they will only
+ * be used when the master is running a write transaction. Read only
+ * transactions never show up in WAL at all and it is valid to ignore them.
+ * So we would only ever use all max_connections procs is we were running
+ * a write transaction on every session at once. As a result, we may be
+ * able to continue running normally even if max_connections is set lower
+ * on the standby than on the master.
+ *
+ * It is theoretically possible for a FATAL error to explode before writing
+ * an abort record. This would then tie up a recovery proc until the next
+ * WAL record containing a valid list of running xids arrives. This is
+ * relatively unlikely, so considered both a minor and an acceptable flaw
+ * in the emulation of transactions during recovery.
  *
  * Portions Copyright (c) 1996-2009, PostgreSQL Global Development Group
  * Portions Copyright (c) 1994, Regents of the University of California
@@ -33,28 +55,50 @@
 
 #include "access/subtrans.h"
 #include "access/transam.h"
-#include "access/xact.h"
+#include "access/xlog.h"
 #include "access/twophase.h"
 #include "miscadmin.h"
+#include "storage/proc.h"
 #include "storage/procarray.h"
 #include "utils/snapmgr.h"
 
+static void UnobservedTransactionsRemoveXid(TransactionId xid);
+static void ProcArrayDisplay(int trace_level);
+
+static RunningXactsData	CurrentRunningXactsData;
 
 /* Our shared memory area */
 typedef struct ProcArrayStruct
 {
 	int			numProcs;		/* number of valid procs entries */
-	int			maxProcs;		/* allocated size of procs array */
+	int			maxProcs;			/* allocated size of total procs array */
+
+	int			numUnobservedXids;	/* number of valid unobserved xids */
+	int			maxUnobservedXids;	/* allocated size of unobserved array */
+	/*
+	 * Last subxid that overflowed unobserved xids array. Similar to
+	 * overflowing subxid cached in PGPROC entries.
+	 */
+	TransactionId	lastOverflowedUnobservedXid;
+
+	bool		allowStandbySnapshots;	/* can queries take snapshots? */
 
 	/*
 	 * We declare procs[] as 1 entry because C wants a fixed-size array, but
 	 * actually it is maxProcs entries long.
 	 */
 	PGPROC	   *procs[1];		/* VARIABLE LENGTH ARRAY */
+
+	/* ARRAY OF UNOBSERVED TRANSACTION XIDs FOLLOWS */
 } ProcArrayStruct;
 
 static ProcArrayStruct *procArray;
 
+/*
+ * Bookkeeping for tracking unobserved transactions in hot standby mode.
+ */
+static TransactionId	latestObservedXid = InvalidTransactionId;
+static bool				RunningXactIsValid = false;
 
 #ifdef XIDCACHE_DEBUG
 
@@ -100,9 +144,14 @@ ProcArrayShmemSize(void)
 	Size		size;
 
 	size = offsetof(ProcArrayStruct, procs);
+
+	/* Allocate space for PGPROC pointers for backends and prepared xacts. */
 	size = add_size(size, mul_size(sizeof(PGPROC *),
 								 add_size(MaxBackends, max_prepared_xacts)));
 
+	/* Allocate space for UnobservedXids. */
+	size = add_size(size, mul_size(sizeof(TransactionId), 65 * MaxBackends));
+
 	return size;
 }
 
@@ -125,6 +174,14 @@ CreateSharedProcArray(void)
 		 */
 		procArray->numProcs = 0;
 		procArray->maxProcs = MaxBackends + max_prepared_xacts;
+
+		/*
+		 * If you change this, also change ProcArrayShmemSize()
+		 */
+		procArray->maxUnobservedXids = 65 * MaxBackends;
+		procArray->numUnobservedXids = 0;
+		procArray->lastOverflowedUnobservedXid = InvalidTransactionId;
+		procArray->allowStandbySnapshots = false;
 	}
 }
 
@@ -302,6 +359,7 @@ ProcArrayClearTransaction(PGPROC *proc)
 	proc->xid = InvalidTransactionId;
 	proc->lxid = InvalidLocalTransactionId;
 	proc->xmin = InvalidTransactionId;
+	proc->lsn = InvalidXLogRecPtr;
 
 	/* redundant, but just in case */
 	proc->vacuumFlags &= ~PROC_VACUUM_STATE_MASK;
@@ -314,6 +372,247 @@ ProcArrayClearTransaction(PGPROC *proc)
 
 
 /*
+ * xidComparator
+ *		qsort comparison function for XIDs
+ */
+static int
+xidComparator(const void *arg1, const void *arg2)
+{
+	TransactionId xid1 = *(const TransactionId *) arg1;
+	TransactionId xid2 = *(const TransactionId *) arg2;
+
+	if (TransactionIdFollows(xid1, xid2))
+		return 1;
+	if (TransactionIdPrecedes(xid1, xid2))
+		return -1;
+	return 0;
+}
+
+static void
+ProcArrayDisplay(int trace_level)
+{
+	ProcArrayStruct *arrayP = procArray;
+	int			index, i;
+	StringInfoData buf;
+
+	for (index = 0; index < arrayP->numProcs; index++)
+	{
+		PGPROC	*proc = arrayP->procs[index];
+		TransactionId	xid = proc->xid;
+		int nsubxids = proc->subxids.nxids;
+
+		initStringInfo(&buf);
+		appendStringInfo(&buf, "procarray %d xid %d lsn %X/%X ",
+							index, xid,
+							proc->lsn.xlogid, proc->lsn.xrecoff);
+		if (nsubxids > 0)
+		{
+			appendStringInfo(&buf, "nsubxids %u : ", nsubxids);
+
+			for (i = 0;	i < nsubxids; i++)
+				appendStringInfo(&buf, "%u ", proc->subxids.xids[i]);
+		}
+
+		elog(trace_level, "%s", buf.data);
+	}
+
+	UnobservedTransactionsDisplay(trace_level);
+}
+
+/*
+ * ProcArrayUpdateRecoveryTransactions -- initialise the proc array in recovery
+ *
+ * Use the data about running transactions on master to either create the
+ * initial state of UnobservedXids, or maintain correctness of its
+ * state. In a sense this is almost the opposite of GetSnapshotData(),
+ * since we are updating the proc array based upon the snapshot. We do this
+ * as a cross-check that the proc array is correctly maintained, because
+ * we know it is possible that some transactions with FATAL errors do not
+ * write abort records and also to create the initial state of the procarray.
+ *
+ * Only used during recovery. Notice the signature is very similar to a
+ * _redo function.
+ */
+void
+ProcArrayUpdateRecoveryTransactions(XLogRecPtr lsn, xl_xact_running_xacts *xlrec)
+{
+	int				xid_index;	/* main loop */
+	TransactionId  *xids;
+	int				nxids;
+
+	if (TransactionIdPrecedes(latestObservedXid, xlrec->latestRunningXid))
+		latestObservedXid = xlrec->latestRunningXid;
+
+	xids = palloc(sizeof(TransactionId) * (xlrec->xcnt + xlrec->subxcnt));
+	nxids = 0;
+
+	ProcArrayDisplay(trace_recovery(DEBUG3));
+
+	/*
+	 * Scan through the incoming array of RunningXacts and collect xids.
+	 * XXX: mark subtransactions with SubtransSetParent here too.
+	 */
+	for (xid_index = 0; xid_index < xlrec->xcnt; xid_index++)
+	{
+		RunningXact		*rxact = (RunningXact *) xlrec->xrun;
+		TransactionId	xid = rxact[xid_index].xid;
+		TransactionId   *subxip = (TransactionId *) &(xlrec->xrun[xlrec->xcnt]);
+		int i;
+
+		xids[nxids++] = xid;
+		for(i = 0; i < rxact[xid_index].nsubxids; i++)
+			xids[nxids++] = subxip[xid_index + rxact[xid_index].subx_offset + i];
+
+		elog(trace_recovery(DEBUG5),
+			"running xact lsn %X/%X xid %d",
+				lsn.xlogid, lsn.xrecoff, rxact[xid_index].xid);
+	}
+
+	/* We keep the unobserved xids array sorted at all times */
+	qsort(xids, nxids, sizeof(TransactionId), xidComparator);
+
+	LWLockAcquire(ProcArrayLock, LW_EXCLUSIVE);
+
+	if (TransactionIdPrecedes(ShmemVariableCache->latestCompletedXid,
+							  xlrec->latestCompletedXid))
+		ShmemVariableCache->latestCompletedXid = xlrec->latestCompletedXid;
+
+	/*
+	 * Left prune the UnobservedXids array up to latestRunningXid.
+	 * This is correct because at the time we take this snapshot, all
+	 * completed transactions prior to latestRunningXid will be marked in
+	 * WAL or they are explicitly present here.
+	 *
+	 * We can't clear the array completely because race conditions allow
+	 * things to slip through sometimes. XXX: We do anyway
+	 */
+	UnobservedTransactionsClearXids();
+
+	UnobservedTransactionsAddXids(InvalidTransactionId, nxids, xids);
+
+	/* Advance global latestCompletedXid while holding the lock */
+	if (TransactionIdPrecedes(ShmemVariableCache->latestCompletedXid,
+							  xlrec->latestCompletedXid))
+		ShmemVariableCache->latestCompletedXid = xlrec->latestCompletedXid;
+
+	/*
+	 * If we fully applied the RunningXact data then we can (re)open
+	 * for business. Whatever state we were in before.
+	 */
+	procArray->allowStandbySnapshots = true;
+	RunningXactIsValid = true;
+
+	ProcArrayDisplay(trace_recovery(DEBUG3));
+
+	LWLockRelease(ProcArrayLock);
+
+	elog(DEBUG2, "Running xact data applied -- standby snapshots now enabled");
+}
+
+/*
+ * During recovery we maintain ProcArray with incoming xids when we first
+ * observe them in use. Uses local variables, so should only be called
+ * by Startup process.
+ *
+ * RecordKnownAssignedTransactionIds() should be run for *every* WAL record
+ * type apart from XLOG_XACT_RUNNING_XACTS, since that initialises the
+ * first snapshot so that RecordKnownAssignedTransactionIds() can be
+ * called. We don't currently check that rmgrs have called us.
+ * XXXHS: Perhaps we should?
+ *
+ * We record all xids that we know have been assigned. That includes
+ * all the xids on the WAL record, plus all unobserved xids that
+ * we can deduce have been assigned. We can deduce the existence of
+ * unobserved xids because we know xids are in sequence, with no gaps.
+ */
+bool
+RecordKnownAssignedTransactionIds(XLogRecPtr lsn, TransactionId xid)
+{
+	/*
+	 * Skip processing if the current snapshot is invalid. If you're
+	 * thinking of removing this, think again. We must have a valid
+	 * initial state before we try to modify it.
+	 */
+	if (!IsRunningXactDataValid())
+		return false;
+
+	/*
+	 * VACUUM records are always sent with InvalidTransactionId, so
+	 * invoke conflict processing if we see a record like this, even
+	 * if there is no xid data to record.
+	 */
+	if (!TransactionIdIsValid(xid))
+		return true;
+
+	/*
+	 * When a newly observed xid arrives, it is frequently the case
+	 * that it is *not* the next xid in sequence. When this occurs, we
+	 * must treat the intervening xids as running also. So we maintain
+	 * a special list of these UnobservedXids, so that snapshots can
+	 * see the missing xids as in-progress.
+	 *
+	 * XXX obsolete comment:
+	 * We maintain both recovery Procs *and* UnobservedXids because we
+	 * need them both. Recovery procs allow us to store top-level xids
+	 * and subtransactions separately, otherwise we wouldn't know
+	 * when to overflow the subxid cache. UnobservedXids allow us to
+	 * make sense of the out-of-order arrival of xids.
+	 *
+	 * Some examples:
+	 * 1)	latestObservedXid = 647
+	 *		next xid observed in WAL = 651 (a top-level transaction)
+	 *		so we add 648, 649, 650 to UnobservedXids
+	 *		and add 651 as a recovery proc
+	 *
+	 * 2)	latestObservedXid = 769
+	 *		next xid observed in WAL = 771 (a subtransaction)
+	 *		so we add 770 to UnobservedXids
+	 *		and add 771 into the subxid cache of its top-level xid
+	 *
+	 * 3)	latestObservedXid = 769
+	 *		next xid observed in WAL = 810 (a subtransaction)
+	 *		810's parent had not yet recorded WAL = 807
+	 *		so we add 770 thru 809 inclusive to UnobservedXids
+	 *		then remove 807
+	 *
+	 * 4)	latestObservedXid = 769
+	 *		next xid observed in WAL = 771 (a subtransaction)
+	 *		771's parent had not yet recorded WAL = 770
+	 *		so do nothing
+	 *
+	 * 5)	latestObservedXid = 7747
+	 *		next xid observed in WAL = 7748 (a subtransaction)
+	 *		7748's parent had not yet recorded WAL = 7742
+	 *		so we add 7748 and removed 7742
+	 */
+	if (TransactionIdFollows(xid, latestObservedXid))
+	{
+		TransactionId	next_expected_xid = latestObservedXid;
+		TransactionIdAdvance(next_expected_xid);
+
+		LWLockAcquire(ProcArrayLock, LW_EXCLUSIVE);
+		UnobservedTransactionsAddRange(next_expected_xid, xid);
+		LWLockRelease(ProcArrayLock);
+
+		latestObservedXid = xid;
+	}
+
+	elog(trace_recovery(DEBUG4),
+		 "record known xact %u latestObservedXid %u",
+		 xid, latestObservedXid);
+	return true;
+}
+
+/*
+ * Is the data available to allow valid snapshots?
+ */
+bool
+IsRunningXactDataValid(void)
+{
+	return RunningXactIsValid;
+}
+
+/*
  * TransactionIdIsInProgress -- is given transaction running in some backend
  *
  * Aside from some shortcuts such as checking RecentXmin and our own Xid,
@@ -590,6 +889,9 @@ GetOldestXmin(bool allDbs, bool ignoreVacuum)
 	TransactionId result;
 	int			index;
 
+	/* Cannot look for individual databases during recovery */
+	Assert(allDbs || !RecoveryInProgress());
+
 	LWLockAcquire(ProcArrayLock, LW_SHARED);
 
 	/*
@@ -656,7 +958,7 @@ GetOldestXmin(bool allDbs, bool ignoreVacuum)
  * but since PGPROC has only a limited cache area for subxact XIDs, full
  * information may not be available.  If we find any overflowed subxid arrays,
  * we have to mark the snapshot's subxid data as overflowed, and extra work
- * will need to be done to determine what's running (see XidInMVCCSnapshot()
+ * *may* need to be done to determine what's running (see XidInMVCCSnapshot()
  * in tqual.c).
  *
  * We also update the following backend-global variables:
@@ -698,17 +1000,23 @@ GetSnapshotData(Snapshot snapshot)
 	if (snapshot->xip == NULL)
 	{
 		/*
-		 * First call for this snapshot
+		 * First call for this snapshot. In recovery we need an additional
+		 * space allocation to allow for UnobservedXids, which never occur
+		 * in normal running.
 		 */
-		snapshot->xip = (TransactionId *)
-			malloc(arrayP->maxProcs * sizeof(TransactionId));
+		if (RecoveryInProgress())
+			snapshot->xip = (TransactionId *)
+				malloc(3 * arrayP->maxProcs * sizeof(TransactionId));
+		else
+			snapshot->xip = (TransactionId *)
+				malloc(arrayP->maxProcs * sizeof(TransactionId));
 		if (snapshot->xip == NULL)
 			ereport(ERROR,
 					(errcode(ERRCODE_OUT_OF_MEMORY),
 					 errmsg("out of memory")));
 		Assert(snapshot->subxip == NULL);
 		snapshot->subxip = (TransactionId *)
-			malloc(arrayP->maxProcs * PGPROC_MAX_CACHED_SUBXIDS * sizeof(TransactionId));
+			malloc((arrayP->maxProcs * PGPROC_MAX_CACHED_SUBXIDS) * sizeof(TransactionId));
 		if (snapshot->subxip == NULL)
 			ereport(ERROR,
 					(errcode(ERRCODE_OUT_OF_MEMORY),
@@ -721,6 +1029,16 @@ GetSnapshotData(Snapshot snapshot)
 	 */
 	LWLockAcquire(ProcArrayLock, LW_SHARED);
 
+	if (RecoveryInProgress() && !arrayP->allowStandbySnapshots)
+	{
+		LWLockRelease(ProcArrayLock);
+		ereport(ERROR,
+			(errcode(ERRCODE_QUERY_CANCELED),
+			 errmsg("canceling statement because standby snapshots are currently disabled"),
+			 errdetail("Valid MVCC snapshot cannot be taken at this time."),
+			 errhint("Contact your administrator if this error recurs frequently")));
+	}
+
 	/* xmax is always latestCompletedXid + 1 */
 	xmax = ShmemVariableCache->latestCompletedXid;
 	Assert(TransactionIdIsNormal(xmax));
@@ -804,6 +1122,52 @@ GetSnapshotData(Snapshot snapshot)
 		}
 	}
 
+	/*
+	 * Also check for unobserved xids. There is no need for us to specify
+	 * that this is only if RecoveryInProgress(), since the list will
+	 * always be empty when normal processing begins and the test will be
+	 * optimised to nearly nothing very quickly.
+	 */
+	if (RecoveryInProgress())
+	{
+		volatile TransactionId	*UnobservedXids;
+		UnobservedXids = (TransactionId *) &(arrayP->procs[arrayP->maxProcs]);
+		for (index = 0; index < arrayP->numUnobservedXids; index++)
+		{
+			TransactionId 	xid;
+
+			/* Fetch xid just once - see GetNewTransactionId */
+			xid = UnobservedXids[index];
+
+			/*
+			 * If there are no more visible xids, we're done. This works
+			 * because UnobservedXids is maintained in strict ascending order.
+			 */
+			if (!TransactionIdIsNormal(xid) || TransactionIdPrecedes(xid, xmax))
+				break;
+
+			/*
+			 * Add unobserved xids onto the main xip array.
+			 */
+			snapshot->xip[count++] = xid;
+
+			/*
+			 * Check to see if this changes xmin. It is possible that an unobserved
+			 * xid could be xmin if there is contention between long-lived
+			 * transactions.
+			 */
+			if (TransactionIdPrecedes(xid, xmin))
+				xmin = xid;
+
+		}
+		/*
+		 * See if we have removed any subxids from the unobserved xids array
+		 * that we might need to see.
+		 */
+		if (!TransactionIdPrecedes(arrayP->lastOverflowedUnobservedXid, xmin))
+			subcount = -1;
+	}
+
 	if (!TransactionIdIsValid(MyProc->xmin))
 		MyProc->xmin = TransactionXmin = xmin;
 
@@ -840,6 +1204,197 @@ GetSnapshotData(Snapshot snapshot)
 }
 
 /*
+ * GetRunningTransactionData -- returns information about running transactions.
+ *
+ * Similar to GetSnapshotData but returning more information. We include
+ * all PGPROCs with an assigned TransactionId, even VACUUM processes. We
+ * also keep track of which subtransactions go with each PGPROC. All of this
+ * looks very similar to GetSnapshotData, but we have more procs and more info
+ * about each proc.
+ *
+ * This is never executed during recovery so there is no need to look at
+ * UnobservedXids.
+ *
+ * We don't worry about updating other counters, we want to keep this as
+ * simple as possible and leave GetSnapshotData() as the primary code for
+ * that bookkeeping.
+ */
+RunningTransactions
+GetRunningTransactionData(void)
+{
+	ProcArrayStruct *arrayP = procArray;
+	static RunningTransactions CurrentRunningXacts = (RunningTransactions) &CurrentRunningXactsData;
+	RunningXact	*rxact;
+	TransactionId *subxip;
+	TransactionId latestRunningXid = InvalidTransactionId;
+	TransactionId latestCompletedXid;
+	TransactionId oldestRunningXid = InvalidTransactionId;
+	int			index;
+	int			count = 0;
+	int			subcount = 0;
+	bool		suboverflowed = false;
+
+	/*
+	 * Allocating space for maxProcs xids is usually overkill; numProcs would
+	 * be sufficient.  But it seems better to do the malloc while not holding
+	 * the lock, so we can't look at numProcs.  Likewise, we allocate much
+	 * more subxip storage than is probably needed.
+	 *
+	 * Should only be allocated for bgwriter, since only ever executed
+	 * during checkpoints.
+	 */
+	if (CurrentRunningXacts->xrun == NULL)
+	{
+		/*
+		 * First call
+		 */
+		CurrentRunningXacts->xrun = (RunningXact *)
+			malloc(arrayP->maxProcs * sizeof(RunningXact));
+		if (CurrentRunningXacts->xrun == NULL)
+			ereport(ERROR,
+					(errcode(ERRCODE_OUT_OF_MEMORY),
+					 errmsg("out of memory")));
+		Assert(CurrentRunningXacts->subxip == NULL);
+		CurrentRunningXacts->subxip = (TransactionId *)
+			malloc((arrayP->maxProcs * PGPROC_MAX_CACHED_SUBXIDS) * sizeof(TransactionId));
+		if (CurrentRunningXacts->subxip == NULL)
+			ereport(ERROR,
+					(errcode(ERRCODE_OUT_OF_MEMORY),
+					 errmsg("out of memory")));
+	}
+
+	rxact = CurrentRunningXacts->xrun;
+	subxip = CurrentRunningXacts->subxip;
+
+	count = 0;
+	subcount = 0;
+	suboverflowed = false;
+
+	LWLockAcquire(ProcArrayLock, LW_SHARED);
+
+	latestCompletedXid = ShmemVariableCache->latestCompletedXid;
+
+	/*
+	 * Spin over procArray checking xid, and subxids. Shared lock is enough
+	 * because new transactions don't use locks at all, so LW_EXCLUSIVE
+	 * wouldn't be enough to prevent them, so don't bother.
+	 */
+	for (index = 0; index < arrayP->numProcs; index++)
+	{
+		volatile PGPROC *proc = arrayP->procs[index];
+		TransactionId xid;
+		int			nxids;
+
+		/* Fetch xid just once - see GetNewTransactionId */
+		xid = proc->xid;
+
+		/*
+		 * We store all xids, even XIDs >= xmax and our own XID, if any.
+		 * But we don't store transactions that don't have a TransactionId
+		 * yet because they will not show as running on a standby server.
+		 */
+		if (!TransactionIdIsValid(xid))
+			continue;
+
+		rxact[count].xid = xid;
+
+		if (TransactionIdPrecedes(latestRunningXid, xid))
+			latestRunningXid = xid;
+
+		if (!TransactionIdIsValid(oldestRunningXid) ||
+			TransactionIdPrecedes(xid, oldestRunningXid))
+			oldestRunningXid = xid;
+
+		/*
+		 * Save subtransaction XIDs.
+		 *
+		 * The other backend can add more subxids concurrently, but cannot
+		 * remove any.	Hence it's important to fetch nxids just once. Should
+		 * be safe to use memcpy, though.  (We needn't worry about missing any
+		 * xids added concurrently, because they must postdate xmax.)
+		 *
+		 * Again, our own XIDs *are* included in the snapshot.
+		 */
+		nxids = proc->subxids.nxids;
+
+		if (nxids > 0)
+		{
+			TransactionId *subxids = (TransactionId *) proc->subxids.xids;
+
+			rxact[count].subx_offset = subcount;
+
+			memcpy(subxip + subcount,
+				   (void *) proc->subxids.xids,
+				   nxids * sizeof(TransactionId));
+			subcount += nxids;
+
+			if (proc->subxids.overflowed)
+			{
+				rxact[count].overflowed = true;
+				suboverflowed = true;
+			}
+
+			if (TransactionIdPrecedes(latestRunningXid, subxids[nxids - 1]))
+				latestRunningXid = subxids[nxids - 1];
+		}
+		else
+		{
+			rxact[count].subx_offset = 0;
+			rxact[count].overflowed = false;
+		}
+
+		rxact[count].nsubxids = nxids;
+		count++;
+	}
+
+	LWLockRelease(ProcArrayLock);
+
+	/*
+	 * When there are no transactions running, just use the value
+	 * of the last completed transaction. No need to check
+	 * ReadNewTransactionId().
+	 */
+	if (count == 0)
+		latestRunningXid = latestCompletedXid;
+
+	CurrentRunningXacts->xcnt = count;
+	CurrentRunningXacts->subxcnt = subcount;
+	CurrentRunningXacts->latestCompletedXid = latestCompletedXid;
+	CurrentRunningXacts->oldestRunningXid = oldestRunningXid;
+	if (suboverflowed)
+		CurrentRunningXacts->latestRunningXid = InvalidTransactionId;
+	else
+		CurrentRunningXacts->latestRunningXid = latestRunningXid;
+
+#ifdef RUNNING_XACT_DEBUG
+	elog(trace_recovery(DEBUG3),
+					"logging running xacts xcnt %d subxcnt %d latestCompletedXid %d latestRunningXid %d",
+					CurrentRunningXacts->xcnt,
+					CurrentRunningXacts->subxcnt,
+					CurrentRunningXacts->latestCompletedXid,
+					CurrentRunningXacts->latestRunningXid);
+
+	for (index = 0; index < CurrentRunningXacts->xcnt; index++)
+	{
+		int j;
+		elog(trace_recovery(DEBUG3),
+					"xid %d nsubxids %d offset %d, ovflow %s",
+					CurrentRunningXacts->xrun[index].xid,
+					CurrentRunningXacts->xrun[index].nsubxids,
+					CurrentRunningXacts->xrun[index].subx_offset,
+					CurrentRunningXacts->xrun[index].overflowed ? "t" : "f");
+		for (j = 0; j < CurrentRunningXacts->xrun[index].nsubxids; j++)
+			elog(trace_recovery(DEBUG3),
+					"subxid offset %d j %d xid %d",
+					CurrentRunningXacts->xrun[index].subx_offset, j,
+					CurrentRunningXacts->subxip[j + CurrentRunningXacts->xrun[index].subx_offset]);
+	}
+#endif
+
+	return CurrentRunningXacts;
+}
+
+/*
  * GetTransactionsInCommit -- Get the XIDs of transactions that are committing
  *
  * Constructs an array of XIDs of transactions that are currently in commit
@@ -969,6 +1524,41 @@ BackendPidGetProc(int pid)
 }
 
 /*
+ * BackendXidGetProc -- get a backend's PGPROC given its XID
+ *
+ * Returns NULL if not found.  Note that it is up to the caller to be
+ * sure that the question remains meaningful for long enough for the
+ * answer to be used ...
+ */
+PGPROC *
+BackendXidGetProc(TransactionId xid)
+{
+	PGPROC	   *result = NULL;
+	ProcArrayStruct *arrayP = procArray;
+	int			index;
+
+	if (xid == InvalidTransactionId)	/* never match invalid xid */
+		return 0;
+
+	LWLockAcquire(ProcArrayLock, LW_SHARED);
+
+	for (index = 0; index < arrayP->numProcs; index++)
+	{
+		PGPROC	   *proc = arrayP->procs[index];
+
+		if (proc->xid == xid)
+		{
+			result = proc;
+			break;
+		}
+	}
+
+	LWLockRelease(ProcArrayLock);
+
+	return result;
+}
+
+/*
  * BackendXidGetPid -- get a backend's pid given its XID
  *
  * Returns 0 if not found or it's a prepared transaction.  Note that
@@ -1029,7 +1619,7 @@ IsBackendPid(int pid)
  *	If limitXmin is not InvalidTransactionId, skip processes with
  *		xmin > limitXmin.
  *	If excludeXmin0 is true, skip processes with xmin = 0.
- *	If allDbs is false, skip processes attached to other databases.
+ *	If dbOid is valid, we skip backends attached to other databases.
  *	If excludeVacuum isn't zero, skip processes for which
  *		(vacuumFlags & excludeVacuum) is not zero.
  *
@@ -1047,7 +1637,7 @@ IsBackendPid(int pid)
  */
 VirtualTransactionId *
 GetCurrentVirtualXIDs(TransactionId limitXmin, bool excludeXmin0,
-					  bool allDbs, int excludeVacuum,
+					  Oid dbOid, int excludeVacuum,
 					  int *nvxids)
 {
 	VirtualTransactionId *vxids;
@@ -1065,13 +1655,13 @@ GetCurrentVirtualXIDs(TransactionId limitXmin, bool excludeXmin0,
 	{
 		volatile PGPROC *proc = arrayP->procs[index];
 
-		if (proc == MyProc)
+		if (proc == MyProc || proc->pid == 0)
 			continue;
 
 		if (excludeVacuum & proc->vacuumFlags)
 			continue;
 
-		if (allDbs || proc->databaseId == MyDatabaseId)
+		if (!OidIsValid(dbOid) || proc->databaseId == dbOid)
 		{
 			/* Fetch xmin just once - might change on us */
 			TransactionId pxmin = proc->xmin;
@@ -1101,6 +1691,219 @@ GetCurrentVirtualXIDs(TransactionId limitXmin, bool excludeXmin0,
 	return vxids;
 }
 
+/*
+ * GetConflictingVirtualXIDs -- returns an array of currently active VXIDs.
+ *
+ * The array is palloc'd and is terminated with an invalid VXID.
+ *
+ * If limitXmin is not InvalidTransactionId, we skip any backends
+ * with xmin >= limitXmin.	If dbOid is valid we skip backends attached
+ * to other databases.  If roleId is valid we skip backends attached
+ * as other roles.
+ *
+ * Be careful to *not* pfree the result from this function. We reuse
+ * this array sufficiently often that we use malloc for the result.
+ * We only ever call
+ */
+VirtualTransactionId *
+GetConflictingVirtualXIDs(TransactionId limitXmin, Oid dbOid, Oid roleId)
+{
+	static VirtualTransactionId *vxids;
+	ProcArrayStruct *arrayP = procArray;
+	int			count = 0;
+	int			index;
+
+	/*
+	 * If not first time through, get workspace to remember main XIDs in. We
+	 * malloc it permanently to avoid repeated palloc/pfree overhead.
+	 * Allow result space, remembering room for a terminator.
+	 */
+	if (vxids == NULL)
+	{
+		vxids = (VirtualTransactionId *)
+			malloc(sizeof(VirtualTransactionId) * (arrayP->maxProcs + 1));
+		if (vxids == NULL)
+			ereport(ERROR,
+					(errcode(ERRCODE_OUT_OF_MEMORY),
+					 errmsg("out of memory")));
+	}
+
+	LWLockAcquire(ProcArrayLock, LW_EXCLUSIVE);
+
+	for (index = 0; index < arrayP->numProcs; index++)
+	{
+		volatile PGPROC *proc = arrayP->procs[index];
+
+		/* Exclude prepared transactions */
+		if (proc->pid == 0)
+			continue;
+
+		if ((!OidIsValid(dbOid) && !OidIsValid(roleId)) ||
+			(proc->databaseId == dbOid && !OidIsValid(roleId)) ||
+			(OidIsValid(dbOid) && proc->roleId == roleId))
+		{
+			/* Fetch xmin just once - can't change on us, but good coding */
+			TransactionId pxmin = proc->xmin;
+
+			/*
+			 * If limitXmin is set we explicitly choose to ignore an invalid
+			 * pxmin because this means that backend has no snapshot and
+			 * cannot get another one while we hold exclusive lock.
+			 */
+			if (!TransactionIdIsValid(limitXmin) ||
+				(TransactionIdPrecedes(pxmin, limitXmin) && TransactionIdIsValid(pxmin)))
+			{
+				VirtualTransactionId vxid;
+
+				GET_VXID_FROM_PGPROC(vxid, *proc);
+				if (VirtualTransactionIdIsValid(vxid))
+					vxids[count++] = vxid;
+			}
+		}
+	}
+
+	LWLockRelease(ProcArrayLock);
+
+	/* add the terminator */
+	vxids[count].backendId = InvalidBackendId;
+	vxids[count].localTransactionId = InvalidLocalTransactionId;
+
+	return vxids;
+}
+
+void
+SetDeferredRecoveryConflicts(TransactionId latestRemovedXid, RelFileNode node,
+							 XLogRecPtr conflict_lsn)
+{
+	ProcArrayStruct *arrayP = procArray;
+	int			index;
+	Oid			dbOid = node.dbNode;
+
+	Assert(InRecovery);
+
+	if (!LatestRemovedXidAdvances(latestRemovedXid))
+		return;
+
+	LWLockAcquire(ProcArrayLock, LW_EXCLUSIVE);
+
+	for (index = 0; index < arrayP->numProcs; index++)
+	{
+		volatile PGPROC *proc = arrayP->procs[index];
+
+		/* Exclude prepared transactions */
+		if (proc->pid == 0)
+			continue;
+
+		if (!OidIsValid(dbOid) || proc->databaseId == dbOid)
+		{
+			/* Fetch xmin just once - can't change on us, but good coding */
+			TransactionId pxmin = proc->xmin;
+
+			/*
+			 * We ignore an invalid pxmin because this means that backend
+			 * has no snapshot and cannot get another one while we hold
+			 * exclusive lock on ProcArrayLock.
+			 */
+			if (!TransactionIdIsValid(latestRemovedXid) ||
+				(TransactionIdPrecedes(pxmin, latestRemovedXid) &&
+				 TransactionIdIsValid(pxmin)))
+			{
+				/*
+				 * Fetch nConflicts just once and make sure we update
+				 * it last to ensure this needs no spinlocks
+				 */
+				int	nConflicts = proc->rconflicts.nConflicts;
+
+				if (nConflicts <= PGPROC_MAX_CACHED_CONFLICT_RELS)
+				{
+					bool 	found = false;
+					int		i;
+
+					if (nConflicts == 0)
+					{
+						/*
+						 * Record the first LSN we come across for *all* rels
+						 * this backend may access since we expect the cache
+						 * to overflow eventually and we'll end up needing to
+						 * use this LSN anyway.
+						 */
+						proc->rconflicts.lsn = conflict_lsn;
+
+						/*
+						 * Zero the cache before we start using it. We do this
+						 * here to avoid doing it during SnapshotResetXmin()
+						 * which would impact the non-recovery code path.
+						 */
+						for (i = 0; i < PGPROC_MAX_CACHED_CONFLICT_RELS; i++)
+							proc->rconflicts.rels[i] = 0;
+					}
+					else
+					{
+						/*
+						 * Search cache to see if it is already listed.
+						 */
+						for (i = 0; i < nConflicts; i++)
+						{
+							if (proc->rconflicts.rels[i] == node.relNode)
+								found = true;
+						}
+					}
+
+					/* If we already have a conflict with this rel, continue */
+					if (found)
+						continue;
+
+					/*
+					 * Add to cache, if there is still space
+					 */
+					if (nConflicts < PGPROC_MAX_CACHED_CONFLICT_RELS)
+						proc->rconflicts.rels[nConflicts] = node.relNode;
+
+					/*
+					 * If nConflicts goes above PGPROC_MAX_CACHED_CONFLICT_RELS
+					 * that means we have overflowed and we won't store any
+					 * more rels.
+					 */
+					proc->rconflicts.nConflicts = ++nConflicts;
+				}
+			}
+		}
+	}
+
+	LWLockRelease(ProcArrayLock);
+}
+
+PGPROC *
+VirtualTransactionIdGetProc(VirtualTransactionId vxid)
+{
+	ProcArrayStruct *arrayP = procArray;
+	PGPROC 		*result = NULL;
+	int			index;
+
+	if (!VirtualTransactionIdIsValid(vxid))
+		return NULL;
+
+	LWLockAcquire(ProcArrayLock, LW_SHARED);
+
+	for (index = 0; index < arrayP->numProcs; index++)
+	{
+		VirtualTransactionId procvxid;
+		PGPROC	   *proc = arrayP->procs[index];
+
+		GET_VXID_FROM_PGPROC(procvxid, *proc);
+
+		if (procvxid.backendId == vxid.backendId &&
+			procvxid.localTransactionId == vxid.localTransactionId)
+		{
+			result = proc;
+			break;
+		}
+	}
+
+	LWLockRelease(ProcArrayLock);
+
+	return result;
+}
 
 /*
  * CountActiveBackends --- count backends (other than myself) that are in
@@ -1240,6 +2043,9 @@ CountOtherDBBackends(Oid databaseId, int *nbackends, int *nprepared)
 	int			autovac_pids[MAXAUTOVACPIDS];
 	int			tries;
 
+	/* Gives wrong answer in recovery, so make sure we don't use it */
+	Assert(!RecoveryInProgress());
+
 	/* 50 tries with 100ms sleep between tries makes 5 sec total wait */
 	for (tries = 0; tries < 50; tries++)
 	{
